module Utils where

import FiniteMap
import Set
import IArray
import Maybe
import IOExts

import Data

debug::Show a=>a->a
debug x = trace (show x) x

findMe::State->Self->Robot
findMe state self = fromJust $ lookupFM (sRobots state) (sId self)

capa::State->Self->Int
capa state self = sCapa self - sum weights
 where
  me = findMe state self
  myPackages = setToList $ rPackages me
  weights = map (\i -> fromJust $ pWeight $ findPackage state i) myPackages

findPackage::State->Int->Package
findPackage state i = pack
 where
  packages = sPackages state
  Just pack = lookupFM packages i

findRobot::State->Int->Robot
findRobot state i = robot
 where
  robots = sRobots state
  Just robot = lookupFM robots i

locateRobot::State->Point->FiniteMap Int Robot
locateRobot state pos = filterFM (\_ r -> rPos r == pos) robots
 where
  robots = sRobots state

countTTW::State->UArray Point Int->Int->(Int,Int)
countTTW state dist i = ((dist ! dest) `div` w,i)
 where
  pack = findPackage state i
  Just w = pWeight pack
  Just dest = pDest pack

isLeft::Either a b->Bool
isLeft (Left _) = True
isLeft (Right _) = False

isRight::Either a b->Bool
isRight (Right _) = True
isRight (Left _) = False

testWeight::Self->Package->Bool
testWeight self pack
 | Nothing <- pWeight pack = True
 | Just w <- pWeight pack = w <= sCapa self

testDestination::Board->Package->Bool
testDestination board pack
 | Nothing <- pDest pack = True
 | Just pos <- pDest pack = bC board ! pos == FEmpty

vic::Point->Point->Int
vic (x1,y1) (x2,y2) = abs (x1-x2) + abs (y1-y2)

addPoint::Point->Point->Point
addPoint (x1,y1) (x2,y2) = (x1 + x2, y1 + y2)

subPoint::Point->Point->Point
subPoint (x1,y1) (x2,y2) = (x1 - x2, y1 - y2)

pointToDir::Point->Dir
pointToDir (0,1)=DNorth
pointToDir (1,0)=DEast
pointToDir (0,-1)=DSouth
pointToDir (-1,0)=DWest
